package info.bukova.isspst.data;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.Table;

import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

@Entity
@Table(name = "REQUIREMENTTYPE")
public class RequirementType extends BaseData {
	
	@Column(name = "TYPE")
	private String type;
	@Column(name = "DESCRIPTION")
	private String description;
	@OneToMany(cascade = CascadeType.ALL)
	@LazyCollection(LazyCollectionOption.FALSE)
	@OrderBy("WORDER")
	private List<Workflow> workflow;
	
	public RequirementType() {
		workflow = new ArrayList<Workflow>();
	}
	
	public RequirementType(String type, String description) {
		this();
		this.type = type;
		this.description = description;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public List<Workflow> getWorkflow() {
		return workflow;
	}

	public void setWorkflow(List<Workflow> workflow) {
		this.workflow = workflow;
	}
	
	public boolean equals(Object o) {
		if (o instanceof RequirementType && ((RequirementType)o).getType().equals(this.type)) {
			return true;
		}
		
		return false;
	}

}
